var o = Object.defineProperty;
var g = (e, t, s) => t in e ? o(e, t, { enumerable: !0, configurable: !0, writable: !0, value: s }) : e[t] = s;
var n = (e, t, s) => (g(e, typeof t != "symbol" ? t + "" : t, s), s);
const c = class c {
  constructor() {
  }
  /**
   * Get the instance of the WPJSSingleton class.
   * @since 1.0.0
   */
  static getInstance() {
    return c._instance || (c._instance = new c()), c._instance;
  }
};
n(c, "_instance");
let h = c;
const p = {
  apiUrl: "https://api.wordpress.org",
  embed: !0
};
class a extends h {
  constructor(s) {
    super();
    n(this, "_config");
    this._config = this.loadConfig(s);
  }
  /**
   * Get the instance
   * @param customConfig
   * @since 1.0.0
   */
  static getInstance(s) {
    return a._instance || (a._instance = new a(s)), a._instance;
  }
  /**
   * Get the config
   *
   * @returns {WPJSConfigOptions}
   * @example
   * import { ConfigManager } from "@quickdevelopment/wp-js";
   *
   * const config = ConfigManager.getInstance();
   *
   * // It will return your earlier provided config
   * console.log(config.getConfig());
   */
  getConfig() {
    return this._config;
  }
  /**
   * Load the config
   * @param customConfig
   * @private
   */
  loadConfig(s) {
    return { ...p, ...s };
  }
}
class r extends h {
  constructor() {
    super();
    n(this, "endpoint", "posts");
    n(this, "_apiUrl", a.getInstance().getConfig().apiUrl);
    n(this, "_searchParams", new URLSearchParams(a.getInstance().getConfig().embed ? "_embed=true" : ""));
  }
  /**
   * Get the endpoint.
   * @private
   */
  getEndpoint() {
    return this.endpoint;
  }
  /**
   * Get the API url.
   * @private
   */
  getApiUrl() {
    return this._apiUrl;
  }
  /**
   * Get the search parameters.
   * @protected
   */
  getSearchParams() {
    return this._searchParams;
  }
  /**
   * Set search parameters for the request.
   * @param params Object containing search parameters.
   * @since 2.0.0
   */
  setSearchParams(s) {
    for (const [i, u] of Object.entries(s))
      u != null && this._searchParams.set(i, u.toString());
    return this;
  }
  /**
   * Get data about the current class.
   * @since 1.0.0
   * @protected
   */
  async get() {
    return console.log(this.constructUrl()), await (await fetch(this.constructUrl())).json();
  }
  /**
   * Fetch a single object from the endpoint.
   * @protected
   * @since 2.0.0
   */
  fetch() {
    return Promise.reject(
      new Error("fetch() must be implemented.")
    );
  }
  /**
   * Fetch multiple objects from the endpoint.
   * @protected
   * @since 2.0.0
   */
  fetchMany() {
    return Promise.reject(
      new Error("fetchMany() must be implemented.")
    );
  }
  /**
   * Construct the url for the request.
   * @private
   * @since 1.0.0
   */
  constructUrl() {
    const s = new URL(`${this.getApiUrl()}/${this.getEndpoint()}`);
    return s.search = this._searchParams.toString(), s.toString();
  }
}
class m extends r {
  constructor(t) {
    super(), this.endpoint = t || "categories";
  }
  /**
   * Fetch a single category.
   * @since 3.0.0
   * @example
   * import { Category } from "@quickdevelopment/wp-js";
   *
   * const category = new Category('categories/1');
   *
   * category.fetch().then((category) => {
   *   console.log(category);
   * })
   */
  async fetch() {
    return this.get();
  }
}
class d extends r {
  constructor(t) {
    super(), this.endpoint = t || "comments";
  }
  /**
   * Fetch a single comment.
   * @since 3.0.0
   * @example
   * import { Comment } from "@quickdevelopment/wp-js";
   *
   * const comment = new Comment('comments/1');
   *
   * comment.fetch().then((comment) => {
   *   console.log(comment);
   * })
   */
  async fetch() {
    return this.get();
  }
}
class f extends r {
  constructor(t) {
    super(), this.endpoint = t || "media";
  }
  /**
   * Fetch a single media.
   * @since 3.0.0
   * @example
   * import {Media} from "@quickdevelopment/wp-js";
   *
   * const media = new Media('media/1');
   *
   * media.fetch().then((media) => {
   *     console.log(media)
   * })
   */
  async fetch() {
    return this.get();
  }
}
class y extends r {
  constructor(t) {
    super(), this.endpoint = t || "pages";
  }
  /**
   * Fetch a single page.
   * @since 3.0.0
   * @example
   * import {Page} from "@quickdevelopment/wp-js";
   *
   * const page = new Page('pages/1');
   *
   * page.fetch().then((page) => {
   *     console.log(page)
   * })
   */
  async fetch() {
    return this.get();
  }
}
class x extends r {
  constructor(s) {
    super();
    n(this, "_slug", "");
    n(this, "_searchTerm", "");
    this.endpoint = s || "posts";
  }
  /**
   * Set the slug.
   * @param slug
   * @since 2.0.0
   * @description
   * This will set the slug. This is useful if you want to get posts from different slugs while keeping the same Post instance.
   * @example
   * import {Post} from "@quickdevelopment/wp-js";
   *
   * const slugPost = new Post();
   *
   * slugPost.bySlug('hello-world').get().then((post) => {
   *     // This will return the post from slug 'hello-world'.
   *     console.log(post)
   * })
   */
  bySlug(s) {
    return this._slug = s, this.setSearchParams({ slug: s }), this;
  }
  /**
   * Get the slug.
   * @since 2.0.0
   */
  getSlug() {
    return this._slug;
  }
  /**
   * Set the searchTerm.
   * @param searchTerm
   * @since 2.0.0
   * @description
   * This will set the searchTerm. This is useful if you want to get posts from different searchTerms while keeping the same Post instance.
   * @example
   * import {Post} from "@quickdevelopment/wp-js";
   *
   * const searchTermPosts = new Post();
   *
   * searchTermPosts.bySearchTerm('hello-world').get().then((posts) => {
   *     // This will return the post from slug 'hello-world'.
   *     console.log(posts)
   * })
   */
  bySearchTerm(s) {
    return this._searchTerm = s, this.setSearchParams({ search: s }), this;
  }
  /**
   * Get the searchTerm.
   * @since 2.0.0
   */
  getSearchTerm() {
    return this._searchTerm;
  }
  /**
   * Set the author.
   * @param userId
   * @since 2.0.0
   * @description
   * This will set the author. This is useful if you want to get posts from different authors while keeping the same Post instance.
   * @example
   * import {Post} from "@quickdevelopment/wp-js";
   *
   * const authorPosts = new Post();
   *
   * authorPosts.byAuthor(1).get().then((posts) => {
   *     // This will return the posts from author with id 1.
   *     console.log(posts)
   * })
   */
  byAuthor(s) {
    return this.setSearchParams({ author: s }), this;
  }
  /**
   * Set the amount of posts to take.
   * @param perPage
   * @param page
   * @since 2.0.0
   * @description
   * This will paginate the posts using per_page and the page query parameters.
   */
  paginate(s, i) {
    return this.setSearchParams({ per_page: s, page: i }), this;
  }
  /**
   * Get a single post.
   * @since 2.0.0
   * @example
   * import {Post} from "@quickdevelopment/wp-js";
   *
   * const post = new Post('posts/1');
   *
   * post.fetch().then((post) => {
   *     console.log(post)
   * })
   */
  async fetch() {
    return this.get();
  }
}
class P extends r {
  constructor(t) {
    super(), this.endpoint = t || "search";
  }
  /**
   * Set the search subtype.
   * @param subtype
   * @since 3.0.0
   * @example
   * import { Search } from "@quickdevelopment/wp-js";
   *
   * const search = new Search();
   * search.setSubtype('post');
   */
  setSubtype(t) {
    return this.setSearchParams({ subtype: t }), this;
  }
  /**
   * Fetch multiple search results.
   * @since 3.0.0
   * @example
   * import { Search } from "@quickdevelopment/wp-js";
   *
   * const search = new Search();
   * search.setSubtype('post').fetch().then((search) => {
   *    console.log(search);
   * })
   */
  async fetchMany() {
    return this.get();
  }
}
class S extends r {
  constructor(t) {
    super(), this.endpoint = t || "statuses";
  }
  /**
   * Fetch a single status.
   * @since 3.0.0
   * @example
   * import { Status } from '@quickdevelopment/wp-js';
   *
   * const status = new Status();
   *
   * status.fetch().then((data) => {
   *     console.log(data);
   * });
   */
  async fetch() {
    return this.get();
  }
}
class _ extends r {
  constructor(t) {
    super(), this.endpoint = t || "tags";
  }
  /**
   * Fetch a single tag.
   * @since 3.0.0
   * @example
   * import { Tag } from '@quickdevelopment/wp-js';
   *
   * const tag = new Tag();
   *
   * tag.fetch().then((data) => {
   *    console.log(data);
   * })
   */
  async fetch() {
    return this.get();
  }
}
class U extends r {
  constructor(t) {
    super(), this.endpoint = t || "taxonomies";
  }
  /**
   * Fetch a single taxonomy.
   * @since 3.0.0
   * @example
   * import { Taxonomy } from '@quickdevelopment/wp-js';
   *
   * const taxonomy = new Taxonomy();
   *
   * taxonomy.fetch().then((data) => {
   *     console.log(data);
   * });
   */
  async fetch() {
    return this.get();
  }
}
class b extends r {
  constructor(t) {
    super(), this.endpoint = t || "types";
  }
  /**
   * Fetch a single type.
   * @since 3.0.0
   * @example
   * import { Type } from "@quickdevelopment/wp-js";
   *
   * const type = new Type('types/post');
   *
   * type.fetch().then((type) => {
   *    console.log(type);
   * });
   */
  async fetch() {
    return this.get();
  }
}
class w extends r {
  constructor(t) {
    super(), this.endpoint = t || "users";
  }
  /**
   * Set the userId.
   * @param userId
   * @since 2.0.0
   * @example
   * import {User} from "@quickdevelopment/wp-js";
   *
   * const user = new User();
   *
   * user.byUserId(1).get().then((user) => {
   *   console.log(user);
   * })
   */
  byUserId(t) {
    return this.endpoint = "users/" + t, this;
  }
  /**
   * Get a single user.
   * @since 2.0.0
   * @example
   * import {User} from "@quickdevelopment/wp-js";
   *
   * const user = new User('users/1');
   *
   * user.fetch().then((user) => {
   *  console.log(user);
   * })
   */
  async fetch() {
    return this.get();
  }
}
export {
  m as Category,
  d as Comment,
  a as ConfigManager,
  f as Media,
  y as Page,
  x as Post,
  P as Search,
  S as Status,
  _ as Tag,
  U as Taxonomy,
  b as Type,
  w as User,
  r as WPJSBase,
  h as WPJSSingleton
};
